<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Models;

use App\Http\Base\BaseModel;

class ItemtransferioModel extends BaseModel
{
	/**
	 * table name from database
	 */
	protected $table = "itempindahbarangio";

	/**
	 *   alias table for relation issues
	 */
	protected $aliasTable = "itemtransferio";

	/**
	 * primary key from table remember eloquent doesnt support composite primary key
	 */
	protected $primaryKey = "id";
	/**
	 * check the incrementing boolean if the incrementing from database is false then the value is false by default
	 */
	// public $incrementing = false;
	/**
	 * fillable property for eloquent attribute cast
	 */
	protected $fillable = [
		"id", "ioNumber", "itemId", "quantity", "lokasiId", "lotNumber", "date_updated", "stokId", "fromLokasiId", "is_sync"

	];
	/**
	 * Creating raw object from table that, this purpose for making you easier for remembering all attribute
	 */


	/**
	 * paging for default paging purpose
	 * if you want to add new paging property you have to add the property in this array
	 * you have to add the relation value
	 * remember this is not suported casting value you have to handle by your self
	 */
	protected $aliasPaging = [];

	/**
	 * relation from ' . item . ' by ' . itemId 
	 * join item on item.id = itemtransferio.itemId
	 * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	 * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	 * @param string $alias
	 * @return $this
	 */
	public function joinRelationItemId($alias = "itemId")
	{
		$this->getQuery()->join("item as $alias", "$alias.id", "=", "itemtransferio.itemId");
		return $this;
	}
	/**
	 * relation from ' . pindahstok . ' by ' . transferIoId 
	 * join pindahstok on pindahstok.id = itemtransferio.transferIoId
	 * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	 * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	 * @param string $alias
	 * @return $this
	 */
	public function joinRelationTransferIoId($alias = "transferIoId")
	{
		$this->getQuery()->join("pindahbarangio as $alias", "$alias.ioNumber", "=", "itemtransferio.ioNumber");
		return $this;
	}

	/**
	 * relation from ' . lokasiItem . ' by ' . lokasiId 
	 * join pindahstok on pindahstok.id = itemtransferio.lokasiId
	 * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	 * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	 * @param string $alias
	 * @return $this
	 */
	public function joinRelationLokasiId($alias = "lokasiId")
	{
		$this->getQuery()->join("lokasiitem as $alias", "$alias.id", "=", "itemtransferio.lokasiId");
		return $this;
	}
	public function joinRelationFromLokasiId($alias = "fromLokasiId")
	{
		$this->getQuery()->join("lokasiitem as $alias", "$alias.id", "=", "itemtransferio.fromLokasiId");
		return $this;
	}


	public function joinRelationStokId($alias = "stokId")
	{
		$this->getQuery()->leftjoin("stokkapal as $alias", "$alias.id", "=", "itemtransferio.stokId");
		return $this;
	}

	public function updateTransactionSyncFlag($TRANSACTION_NUM, $ITEM_ID, $LOT_NUMBER)
	{
		$model = (new self())->getQuery()->where("itemtransferio.ioNumber", "=", $TRANSACTION_NUM)
			->where("itemtransferio.itemId", "=", $ITEM_ID)
			->where("itemtransferio.lotNumber", "=", $LOT_NUMBER)->first();
		if ($model) {
			$model = self::find($model->id);
			$model->is_sync = 1;
			$model->update();
			// (new LogsynckapalModel)->setLogSync("Update Sync Flag Transfer IO: " . $TRANSACTION_NUM . " - " . $LOT_NUMBER . " - " . $LOT_NUMBER, Carbon::now()->toDateTimeString(), "", "updated");
		}
	}

	// RETURN NUMBER OF ROWS AS INTEGER, FOR ITEMS WITH LOT_NUMBER AND IS_SYNC IS NULL
	public function validUpdateStock($ITEM_ID, $LOT_NUMBER)
	{
		$model = (new self())->getQuery()
			->selectRaw('COUNT("itemtransferio"."itemId") as "nItems"')
			->where("itemtransferio.itemId", "=", $ITEM_ID)
			->where("itemtransferio.lotNumber", "=", $LOT_NUMBER)
			->whereNull("itemtransferio.is_sync")
			->groupBy("itemId")
			->first();
		if ($model) {
			return $model->nItems;
		} else {
			return 0;
		}
	}
}
